    list	P=16F84A
    #include	<P16F84A.INC>
    __CONFIG	_XT_OSC & _WDT_OFF & _PWRTE_ON & _CP_OFF
;XCb`͋L
SW_0	EQU	0X0C
;vp[
ONE_OF_100	EQU	SW_0+1
SECOND	EQU	ONE_OF_100+1
;
CNTR_BLINK	EQU SECOND+1
MEAS_STATUS	EQU	CNTR_BLINK+1
;
    ORG		0X0000	;START ADDRESS
    GOTO	INITIAL	;[`
;
    ORG		0X0004	;荞ݏJnAhX
    BCF		STATUS,RP0
;
    MOVLW	HIGH(COUNT)	;vƕ\
    MOVWF	PCLATH
    CALL	COUNT
;
    MOVLW	INTCON
    MOVWF	FSR
    BCF		INDF,T0IF
;
    RETFIE
;    [`
INITIAL:
    BCF		STATUS,RP0
    MOVLW	INTCON
    MOVWF	FSR
    CLRF	INDF	;荞݂֎~
    MOVLW	TRISA
    MOVWF	FSR
    MOVLW	0X08
    MOVWF	INDF	    ;SET RA<2:0> AS OUTPUT,
						;RA<3> AS INPUT,
						;RA<4> AS OUTPUT.
	MOVLW	0X02
	MOVWF	PORTA
;
    MOVLW	TRISB	    ;SET RB<7:0> AS OUTPUT.
    MOVWF	FSR
    CLRF	INDF
	CLRF	PORTB	    ;|[gB=0X00
;
    MOVLW	SW_0
    MOVWF	FSR
LOOP_CLR:
    CLRF	INDF
    MOVFW	FSR
    SUBLW	0X4F
    BTFSC	STATUS,Z
    GOTO	INIT_SW
    INCF	FSR,F
    GOTO	LOOP_CLR
;XCb`̏l荞
INIT_SW:
    BCF		STATUS,RP0  ;BANK0
    MOVFW	PORTA
    ANDLW	0X08
    MOVWF	SW_0
;1/100b̊荞݂ݒ肷    
SETUP_TIMER_AND_INT:
    MOVLW	OPTION_REG
    MOVWF	FSR
    MOVLW	0X84	;PORTB PULL-UP WAS DISABLED
			;TMR0 CLOCK SOURCE Fosc/4
			;PSA TMR0
			;PS2:0 1:32
    MOVWF	INDF  ;
    MOVLW	INTCON		;
    MOVWF	FSR
    BSF		INDF,T0IE
    BSF		INDF,GIE
;荞ݑ҂̃AChTCN    
IDLE:
    BCF		STATUS,RP0
    MOVFW	MEAS_STATUS
    NOP
	NOP
	NOP
    GOTO	IDLE
;
;vƕ\
    ORG	    0X0100
COUNT:
	BCF		STATUS,RP0
	CLRW
	SUBWF	MEAS_STATUS,W
	BTFSC	STATUS,Z		;҂H		
    GOTO	READ_BCD_SW		;҂ȂBCDXCb`ǂݏo
    MOVLW	0X01			;҂H
    SUBWF	MEAS_STATUS,W
	BTFSC	STATUS,Z
    GOTO	COUNT_DOWN		;҂ȂJEg_E
	GOTO	BLINK			;Ԓ߁A_ŏ
;BCDXCb`ǂݏo
READ_BCD_SW:
	CLRF	PORTB		;SET PORTB TO@Low LEBEL
	MOVLW	TRISB
	MOVWF	FSR
	MOVLW	0XFF		;SET PORTB TO INPUT
	MOVWF	INDF
	BSF		PORTA,RA2	;ENABLE BCD SW
	BSF		PORTA,RA1	;DISABLE BLANK
	MOVFW	PORTB		;INPUT BCD SW
	CLRF	ONE_OF_100	;CLEAR 1/100Sec.
	MOVWF	SECOND		;SAVE READ TO COUNT FILE
	CLRF	CNTR_BLINK
	BCF		PORTA,RA2	;DISABLE BCD SW
	CLRF	INDF		;SET PORTB TO OUTPUT-PORT AGAIN
	MOVWF	PORTB		;DISPLAY TIME
	BCF		PORTA,RA0
	BSF		PORTA,RA0
;
	GOTO	PUSH_SW		;{^XCb`
;
;҂
COUNT_DOWN:
	MOVLW	0X01		;1/100bJEg_E
	SUBWF	ONE_OF_100,F	;
	BTFSC	STATUS,C	;*{[B
	GOTO	NOT_BO		;{[ȂDC
	MOVLW	0X99
	MOVWF	ONE_OF_100
	GOTO	DOWN_SEC	;0.99bݒ肵1bJEg_E
NOT_BO:
	BTFSC	STATUS,DC	;DCZbgĂȂΉʌŃ{[
	GOTO	PUSH_SW		;{^XCb`
	MOVLW	0X06		;ʌ10i␳
	SUBWF	ONE_OF_100,F
	GOTO	PUSH_SW		;{^XCb`
;
DOWN_SEC:
	MOVLW	0X01		;1bJEg_E
	SUBWF	SECOND,F
	BTFSC	STATUS,C
	GOTO	NOT_BO_SEC	;10bŃ{[Ȃ
	MOVLW	0X99		;99bݒ肵ăJEgI
	MOVWF	SECOND
	GOTO	PUSH_SW		;{^XCb`
NOT_BO_SEC:
	BTFSC	STATUS,DC	;DCZbgĂȂΉʌŃ{[
	GOTO	PUSH_SW		;{^XCb`
	MOVLW	0X06		;ʌ10i␳
	SUBWF	SECOND,F
	GOTO	PUSH_SW		;{^XCb`
;
BLINK:
	INCF	CNTR_BLINK,F	;_ŎpJE^|
	BTFSC	CNTR_BLINK,3
	GOTO	ON_LED
	BCF		PORTA,1
	GOTO	PUSH_SW
ON_LED:
	BSF		PORTA,1
	GOTO	PUSH_SW
;
PUSH_SW:
	MOVFW	PORTA
	ANDLW	0X08
	BTFSS	STATUS,Z
	GOTO	SW_ON
	MOVWF	SW_0	;ŐVZ[u
	GOTO	DISP	;\
;XCb`ꂽ
SW_ON:
	BTFSC	SW_0,3
	GOTO	NO_OFF	;XCb`܂ĂȂ
	MOVWF	SW_0
	MOVFW	MEAS_STATUS	
	BTFSC	STATUS,Z	;҂H
	GOTO	START_COUNT	;START COUNT-DOWN
	GOTO	START_IDLE	;҂Jn
START_COUNT:
	MOVLW	0X01
	MOVWF	MEAS_STATUS
	GOTO	DISP
START_IDLE:
	CLRF	MEAS_STATUS
NO_OFF:
	GOTO	DISP
;
DISP:
	MOVLW	0X01
	SUBWF	MEAS_STATUS,W
	BTFSS	STATUS,Z
	GOTO	DISP2
	MOVFW	SECOND
	BTFSS	STATUS,Z
	GOTO	DISP2
	MOVFW	ONE_OF_100
	BTFSS	STATUS,Z
	GOTO	DISP2
	MOVLW	0X02
	MOVWF	MEAS_STATUS
DISP2:
	MOVFW	SECOND
	BCF		PORTA,2		;DISABLE BCD SW
	CLRF	TRISB		;SET PORTB TO OUTPUT-PORT
	MOVWF	PORTB		;DISPLAY TIME
	BCF		PORTA,0
	BSF		PORTA,0
;
	RETURN		;
    END